﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
//using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.GridHelperClasses;
using Syncfusion.Drawing;
using Syncfusion.GroupingGridExcelConverter;
using Syncfusion.GridExcelConverter;
using Syncfusion.Windows.Forms;

namespace WindowsFormsApplication21
{

    public partial class Form1 : Form
    {
        ScrollersFrame sc;
        DataTable inputTable;
        DataTable mergeTable;
        BindingSource bs;
        Rectangle rect;

        public Form1()
        {
            InitializeComponent();
            this.gridGroupingControl1.GridOfficeScrollBars = OfficeScrollBars.Office2010;
            //data binding
            // I use a bindingsource to bind also other controls to the datasource.
            bs = new BindingSource();
            bs.DataSource = ReturnATable();
            // example:
            this.textBox1.DataBindings.Add(new Binding("Text", bs, "value"));
            this.gridGroupingControl1.DataSource = bs; //ReturnATable();
            //to hide groupdroparea
            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = true;
            //to hide the caption text
            this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = true;
            //to customize the caption text
            this.gridGroupingControl1.TopLevelGroupOptions.CaptionText = "customize";
            //this.gridGroupingControl1.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
            //this.gridGroupingControl1.TableModel.QueryColWidth += new GridRowColSizeEventHandler(TableModel_QueryColWidth);
            //this.gridGroupingControl1.TableModel.QueryRowHeight += new GridRowColSizeEventHandler(TableModel_QueryRowHeight);
        }

        void TableModel_QueryRowHeight(object sender, GridRowColSizeEventArgs e)
        {
            int cellsize = e.Size;
        }

        void TableModel_QueryColWidth(object sender, GridRowColSizeEventArgs e)
        {
            int cellsize = e.Size;
        }

        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            //this.gridGroupingControl1[e.TableCellIdentity.RowIndex,e.TableCellIdentity.ColIndex]
            // e.Style.getboun
            rect = this.gridGroupingControl1.TableControl.RangeInfoToRectangle(GridRangeInfo.Cell(e.TableCellIdentity.RowIndex, e.TableCellIdentity.ColIndex));
            MessageBox.Show("cell bounds:" + rect+ "Cell Width:"+rect.Width+"Cell Height:"+rect.Height);
        }


        #region datasource
        private DataTable ReturnATable()
        {
            inputTable = new DataTable("Sample");

            //Adds two columns.
            inputTable.Columns.Add(new DataColumn("Id"));
            inputTable.Columns.Add(new DataColumn("A"));
            inputTable.Columns.Add(new DataColumn("B"));
            inputTable.Columns.Add(new DataColumn("Date"));
            inputTable.Columns.Add(new DataColumn("Value"));

            DataColumn[] pk = new DataColumn[1];
            pk[0] = inputTable.Columns["Id"];
            inputTable.PrimaryKey = pk;
          
            //Adds some rows.
            DataRow dr = inputTable.NewRow();
            dr["Id"] = "1";
            dr["A"] = "1";
            dr["B"] = "1";
            dr["Date"] = "22/5/2015";
            dr["Value"] = "-0.67";
            inputTable.Rows.Add(dr);

            dr = inputTable.NewRow();
            dr["Id"] = "2";
            dr["A"] = "1";
            dr["B"] = "1";
            dr["Date"] = "12/1/2015";
            dr["Value"] = "-0.25";
            inputTable.Rows.Add(dr);

            dr = inputTable.NewRow();
            dr["Id"] = "3";
            dr["A"] = "1";
            dr["B"] = "2";
            dr["Date"] = "18/6/2015";
            dr["Value"] = "-0.93";
            inputTable.Rows.Add(dr);

            dr = inputTable.NewRow();
            dr["Id"] = "4";
            dr["A"] = "1";
            dr["B"] = "2";
            dr["Date"] = "12/4/2015";
            dr["Value"] = "0.15";
            inputTable.Rows.Add(dr);

            dr = inputTable.NewRow();
            dr["Id"] = "5";
            dr["A"] = "1";
            dr["B"] = "1";
            dr["Date"] = "27/2/2015";
            dr["Value"] = "0.35";
            inputTable.Rows.Add(dr);

            return inputTable;
        }

        private DataTable ReturnATableToMerge()
        {
            mergeTable = new DataTable("Merge");

            //Adds two columns.
            mergeTable.Columns.Add(new DataColumn("Id"));
            mergeTable.Columns.Add(new DataColumn("A"));
            mergeTable.Columns.Add(new DataColumn("B"));
            mergeTable.Columns.Add(new DataColumn("Date"));
            mergeTable.Columns.Add(new DataColumn("Value"));

            //Adds some rows.
            DataRow dr = mergeTable.NewRow();
            dr["Id"] = "1";
            dr["A"] = "1";
            dr["B"] = "1";
            dr["Date"] = "22/5/2015";
            dr["Value"] = "5.00";
            mergeTable.Rows.Add(dr);

            dr = mergeTable.NewRow();
            dr["Id"] = "2";
            dr["A"] = "1";
            dr["B"] = "1";
            dr["Date"] = "12/1/2015";
            dr["Value"] = "6.00";
            mergeTable.Rows.Add(dr);

            dr = mergeTable.NewRow();
            dr["Id"] = "3";
            dr["A"] = "1";
            dr["B"] = "2";
            dr["Date"] = "18/6/2015";
            dr["Value"] = "7.00";
            mergeTable.Rows.Add(dr);

            dr = mergeTable.NewRow();
            dr["Id"] = "4";
            dr["A"] = "1";
            dr["B"] = "2";
            dr["Date"] = "12/4/2015";
            dr["Value"] = "0.15";
            mergeTable.Rows.Add(dr);

            dr = mergeTable.NewRow();
            dr["Id"] = "5";
            dr["A"] = "1";
            dr["B"] = "1";
            dr["Date"] = "27/2/2015";
            dr["Value"] = "0.35";
            mergeTable.Rows.Add(dr);

            return mergeTable;
        }

        #endregion

        private void button1_Click(object sender, EventArgs e)
        {
            this.inputTable.AcceptChanges();
            this.gridGroupingControl1.Refresh();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            DataTable x = ReturnATableToMerge();
            // I get the changed rows from the database and merge it to my datatable
            inputTable.Merge(x);
            // This should help, but doesn't. Description: "Updates the display after changes were made to schema or data in the engine or datasource."
            this.gridGroupingControl1.Update();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            DataRow dr = inputTable.Rows[0];
            dr["Value"] = "3.00";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            DataTable x = ReturnATableToMerge();
            // I get the changed rows from the database and merge it to my datatable
            inputTable.Merge(x);
            // This helps, but i have to restore the current cell and move to it.
            this.gridGroupingControl1.Reinitialize();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            this.gridGroupingControl1.RecordNavigationBar.MoveFirst();
        }

            
    }
}
